# -*- coding: utf-8 -*-
# Parameters type
PARAM_TYPE_ACQU=1
PARAM_TYPE_PROC=2
PARAM_TYPE_MISC=3

# Type of nmr graph
NMRGRAPH_TYPE_SPC=0
NMRGRAPH_TYPE_FID=1
NMRGRAPH_TYPE_DEPAKED=2

# Units
UNITS_PTS=0
UNITS_PPM=1
UNITS_HZ=2
UNITS_SEC=3

# Graph interaction
NMRGRAPH_INTERACTION_NONE="NONE"
NMRGRAPH_INTERACTION_ZOOM_NMR="NMRZOOM"
NMRGRAPH_INTERACTION_ZOOM_RECT="RECTZOOM"
NMRGRAPH_INTERACTION_MEASURE="MEASURE"
NMRGRAPH_INTERACTION_PAN="PAN"
NMRGRAPH_INTERACTION_MOVE_LINE="MOVE LINE"

# Fid unshuffling
FID_UNSHUF_NONE=0
FID_UNSHUF_HORZ=1
FID_UNSHUF_VERT=2

# Menu constant
MENU_FILE=0
MENU_HELP=1

# Message types
MESSAGE_INFO = 0
MESSAGE_AVERT = 1
MESSAGE_ERROR = 2

# Notebook page type
NOTEBOOK_PAGE_SPECTRUM=0
NOTEBOOK_PAGE_FID=1
NOTEBOOK_PAGE_TITLE=2
NOTEBOOK_PAGE_ACQU_PARAM=3
NOTEBOOK_PAGE_PROC_PARAM=4
NOTEBOOK_PAGE_MISC_PARAM=5
NOTEBOOK_PAGE_MOMENTS=6
NOTEBOOK_PAGE_DEPAKED=7

# Toolbar button types
TOOLBAR_TOGGLE_BUTTON=0
TOOLBAR_BUTTON=1
TOOLBAR_RADIO_BUTTON=2

# Options Constants

#Option types
OPTION_TYPE_NUM=0
OPTION_TYPE_STR=1
OPTION_TYPE_BOOL=2

# Default options values
DEFAULT_OPTIONS=(("grid",True,OPTION_TYPE_BOOL),
                 ("last_opened","",OPTION_TYPE_STR),
                 ("last_saved","",OPTION_TYPE_STR),
                 ("last_imported","",OPTION_TYPE_STR),
                 ("last_imported_folder","",OPTION_TYPE_STR),
                 ("last_exported_set","",OPTION_TYPE_STR),
                 ("last_exported_window","",OPTION_TYPE_STR),
                 ("spectrum_units",UNITS_PTS,OPTION_TYPE_NUM),
                 ("fid_units",UNITS_PTS,OPTION_TYPE_NUM),
                 ("fid_unshuffling",FID_UNSHUF_NONE,OPTION_TYPE_NUM)
                 )


# NMR Friend package constants
Name = "NMR Friend"
Version = "{Dev-Version}"
Authors = [u"Sébastien Buchoux <seb.bubuntu@gmail.com>"]
Copyright = u"Copyright © 2007-2008\nSébastien Buchoux <seb.bubuntu@gmail.com>"
Description = "NMR Friend is a little tool for Solid State NMR."
License = """This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>"""