import gtk

# NMR Friend imports
import NMRFriend

_default_ui=\
"""
<ui>
    <menubar name="MenuBar">
      <menu action="File">
        <menuitem action="Import_spectrum"/>
        <separator/>
        <menuitem action="Export_spectrum"/>
        <separator/>
        <menuitem action="Quit"/>
      </menu>
      <menu action="Help">
        <menuitem action="About"/>
      </menu>
    </menubar>
</ui>
"""

class Menu(gtk.UIManager):
    """Handles NMR Friend Menus"""

    def __init__(self):
    
        _default_actions=[('Quit', gtk.STOCK_QUIT, '_Quit', None,'Exit NMR Friend', self.quit_cb),
                          ('Import_spectrum', gtk.STOCK_CONVERT, '_Import Bruker spectrum', None,'Import spectrum', self.import_spc_cb),
                          ('Export_spectrum', gtk.STOCK_SAVE_AS, '_Export spectrum to ASCII...', None,'Export spectrum', self.export_spectrum_cb),
                          ('File', None, '_File'),
                          ('Help', None, '_Help'),
                          ('About', gtk.STOCK_ABOUT, '_About...', None,'About NMR Friend', self.about_cb)
                          ]
        
        # Call ancestor __init__
        gtk.UIManager.__init__(self)
        
        # Loads default UI
        self.add_ui_from_string(_default_ui)
        
        # Loads default actions
        default_actions=gtk.ActionGroup('Default')
        default_actions.add_actions(_default_actions)
        
        # Add default actions to UIManager
        self.insert_action_group(default_actions, 0)
  
    def quit_cb(self,item):
        NMRFriend.Commands.exit()  

    def import_spc_cb(self,item):
        NMRFriend.Commands.import_spectrum()
  
    def export_spectrum_cb(self,item):
        NMRFriend.Commands.export_spectrum()
  
    def about_cb(self,item):
        NMRFriend.Commands.show_about()