import gtk
import os
import sys

# NMR Friend import
import NMRFriend

class NMR_Friend(gtk.Window):
  
    def __init__(self):
    
        # Call ancestor __init__
        gtk.Window.__init__(self)
        
        # Init Components
        self.init_components()
        
        # Window widget setup
        self.set_title("NMR Friend")
        self.set_default_size(800, 600)
        self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
        self.set_resizable(True)
        
        # Initialize children widgets
        self.vbox = gtk.VBox()
        self.menu_widget = self.menu.get_widget("/MenuBar")
        
        # Pack widgets
        self.vbox.pack_start(self.menu_widget, False)
        self.vbox.pack_start(self.main_view, True)
        self.vbox.pack_start(self.statusbar, False)
        
        # Add Vbox to window widget
        self.add(self.vbox)
        
        # Connect accelerators
        self.add_accel_group(self.menu.get_accel_group())
        
        # Show all widgets
        self.show_all()
    
        # Connect callbacks
        self.connect("delete_event", NMRFriend.Commands.exit)
        self.connect("button-release-event",NMRFriend.Commands.remove_status)
        
        
    def init_components(self):
        self.options = NMRFriend.Options.load_default_optionset()
        self.menu = NMRFriend.Menu.Menu()
        self.main_view = NMRFriend.NmrDisplay.NMR_Notebook()
        self.statusbar = NMRFriend.Statusbar.NMRFriend_Statusbar()
        self.about = NMRFriend.About.About()
        
    def init_display(self):
        try:
            NMRFriend.Commands.import_spectrum_from_path(sys.argv[1])
        except IndexError:
            NMRFriend._active_object = None
        
        self.update_display()
        
        self.show()
    
    def update_display(self):
        self.main_view.rebuild()
