import sys
import gtk, pango
from cStringIO import *
import traceback

App_loaded = False

def _info(type, value, tb):
    if type==KeyboardInterrupt:
        sys.exit("KeyboardInterrupt")
    
    elif type==NotImplementedError:
        dialog = gtk.MessageDialog(parent=None,
                                   flags=gtk.DIALOG_MODAL,
                                   type=gtk.MESSAGE_INFO,
                                   buttons=gtk.BUTTONS_CLOSE,
                                   message_format="")
        dialog.set_title("Feature not Available!")
        dialog.set_markup("Sorry dude!\nThis feature has not been implemented yet!")
        dialog.run()
        dialog.destroy()

    else:
        
        string="<b><big>An unhandled exception has been detected during the execution of this program</big></b>.\n\nIt is not fatal but it may affect current process."
        dialog = gtk.MessageDialog(parent=None,
                                   flags=gtk.DIALOG_MODAL,
                                   type=gtk.MESSAGE_WARNING,
                                   buttons=gtk.BUTTONS_NONE,
                                   message_format="")
        dialog.set_title("Unexpected error!")
        dialog.set_markup(string)
        dialog.set_resizable(True)
        showButton = dialog.add_button("Show Details...", 1)
        hideButton = dialog.add_button("Hide Details", 2)
        hideButton.hide()
        dialog.add_button(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE)
        
        # Details
        textview = gtk.TextView(); textview.show()
        textview.set_editable(False)
        textview.modify_font(pango.FontDescription("Monospace"))
        sw = gtk.ScrolledWindow(); sw.show()
        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        sw.add(textview)
        frame = gtk.Frame();
        frame.set_shadow_type(gtk.SHADOW_IN)
        frame.add(sw)
        frame.set_border_width(6)
        dialog.vbox.add(frame)
        textbuffer = textview.get_buffer()
        trace = StringIO()
        traceback.print_exception(type, value, tb, None, trace)
        #print trace.getvalue()
        textbuffer.set_text(trace.getvalue())
        textview.set_size_request(width=-1, height=150)
        
        dialog.details = frame
        dialog.set_position(gtk.WIN_POS_CENTER)
        dialog.set_gravity(gtk.gdk.GRAVITY_NORTH)
        
        while 1:
            resp = dialog.run()
            if resp == 1:
                dialog.details.show()
                showButton.hide()
                hideButton.show()
            elif resp==2:
                dialog.details.hide()
                showButton.show()
                hideButton.hide()
            else: break
        dialog.destroy()
        
        if not App_loaded:
            sys.exit(1)

sys.excepthook = _info

if __name__ == "__main__":
    1/0
