import sys,gtk,pango,traceback
from cStringIO import *
import threading
import time

# NMR Friend import
import NMRFriend
import Util

def message_die(message="Unkown event!\nSomething happened but I really don't know what!", messagetype = NMRFriend.MESSAGE_INFO):   
    if messagetype == NMRFriend.MESSAGE_INFO:
        GTKmessagetype = gtk.MESSAGE_INFO
        title = "Information"
        outputMessage=message
    elif messagetype == NMRFriend.MESSAGE_AVERT:
        GTKmessagetype = gtk.MESSAGE_WARNING
        title = "Warning"
        outputMessage="<b>"+message+"</b>"
    else :
        GTKmessagetype = gtk.MESSAGE_ERROR
        title = "Error!"
        outputMessage="<b>"+message+"</b>"
        
    dialog = gtk.MessageDialog(parent=None,
                flags=gtk.DIALOG_MODAL,
                type = GTKmessagetype,
                buttons=gtk.BUTTONS_NONE,
                message_format="")
    dialog.set_title(title)
    dialog.set_markup(outputMessage)
    dialog.set_border_width(10)
    #dialog.add_button(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE)
    
    if messagetype!=gtk.MESSAGE_INFO:
        
        showButton = dialog.add_button("Show Details...", 1)
        hideButton = dialog.add_button("Hide Details", 2)
        hideButton.hide()
        
        
        # Details
        textview = gtk.TextView(); textview.show()
        textview.set_editable(False)
        textview.modify_font(pango.FontDescription("Monospace"))
        sw = gtk.ScrolledWindow(); sw.show()
        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        sw.add(textview)
        frame = gtk.Frame();
        frame.set_shadow_type(gtk.SHADOW_IN)
        frame.add(sw)
        frame.set_border_width(6)
        dialog.vbox.add(frame)
        textbuffer = textview.get_buffer()
        trace = StringIO()
        traceback.print_exception(sys.exc_type, sys.exc_value, sys.exc_traceback, None, trace)
        textbuffer.set_text(trace.getvalue())
        #textbuffer.set_text(str(sys.exc_info()[0]))
        textview.set_size_request(width=-1, height=150)
        
        dialog.details = frame
    dialog.set_position(gtk.WIN_POS_CENTER)
    dialog.set_gravity(gtk.gdk.GRAVITY_NORTH)
    
    dialog.add_button(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE)
    
    while 1:
        resp = dialog.run()
        #print "resp:",resp
        if resp == 1:
            dialog.details.show()
            showButton.hide()
            hideButton.show()
        elif resp==2:
            dialog.details.hide()
            showButton.show()
            hideButton.hide()
        else: break
    dialog.destroy()

    #dialog.set_position(gtk.WIN_POS_CENTER)
    #dialog.set_gravity(gtk.gdk.GRAVITY_CENTER)
    #dialog.run()
    #dialog.destroy()

def displayHelp(command,help):
    message="Help on <b><i>"+command+"</i></b> command:\n\n"
    message+=help
    
    dialog = gtk.MessageDialog(parent=None,
                flags=gtk.DIALOG_MODAL,
                type = gtk.MESSAGE_INFO,
                buttons=gtk.BUTTONS_CLOSE,
                message_format="")
    dialog.set_title("Someone needs help?")
    dialog.set_markup(message)
    dialog.set_border_width(10)
    dialog.set_position(gtk.WIN_POS_CENTER)
    dialog.set_gravity(gtk.gdk.GRAVITY_NORTH)
    
    dialog.run()
    dialog.destroy()
    
def confirm_choice(text_to_display):
    """Open a dialog to ask for a confirmation"""
    
    dialog = gtk.MessageDialog(parent=None,
                flags=gtk.DIALOG_MODAL,
                type = gtk.MESSAGE_QUESTION,
                buttons=gtk.BUTTONS_YES_NO,
                message_format="")
    dialog.set_title("Confirmation needed")
    dialog.set_markup(text_to_display)
    dialog.set_border_width(10)
    dialog.set_position(gtk.WIN_POS_CENTER)
    dialog.set_gravity(gtk.gdk.GRAVITY_NORTH)
    
    response=dialog.run()
    dialog.destroy()
    
    if response==gtk.RESPONSE_YES:
        return True
    else:
        return False

def set_param_window(param_name,param_value):
    """Open dialog to change a parameter value"""
    title="Set parameter value"
    outputMessage="\nSet new value for <b><i>"+str(param_name)+"</i></b>:"
    dialog = gtk.MessageDialog(parent=None,
                flags=gtk.DIALOG_MODAL,
                type = gtk.MESSAGE_QUESTION,
                buttons=gtk.BUTTONS_NONE,
                message_format="")
    dialog.set_title(title)
    dialog.set_markup(outputMessage)
    dialog.set_border_width(10)
    dialog.add_button(gtk.STOCK_APPLY, gtk.RESPONSE_OK)
    dialog.add_button(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE)
    dialog.set_default_response(gtk.RESPONSE_OK)
    
    #Add Entry
    entry=gtk.Entry()
    entry.set_width_chars(20)
    entry.set_text(str(param_value))
    entry.set_activates_default(True)
    entry.show()
    
    dialog.vbox.add(entry)
    while 1:
        resp = dialog.run()
        #print "resp:",resp
        if resp == gtk.RESPONSE_OK:
            response=entry.get_text().strip()
            if Util.isNumber(response):
                break
            else:
                message_die("This is not a number!")
                entry.set_text(str(param_value))
        else:
            response=str(param_value)
            break
        
    dialog.destroy()
    return response

def getpathfromfileChooser(title="NMR Friend",action="open",filefilter=["nmr","all"]):
    """
    Open a window with a file chooser et return the file (or folder) path.
    title is a string containing dialog title
    action is one of the following string: 'select_folder', 'save' or 'open'
    filefilter is a list containing file extension desired
    """
    
    # Get correct action for dialog and set correct buttons to use
    if action=="select_folder":
      gtkaction=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER
      gtkbuttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OPEN, gtk.RESPONSE_OK)
      path=NMRFriend.main_app.options.get_option("last_imported_folder")
      
    elif action=="save":
      gtkaction=gtk.FILE_CHOOSER_ACTION_SAVE
      gtkbuttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_SAVE, gtk.RESPONSE_OK)
      path=NMRFriend.main_app.options.get_option("last_saved")
      
    elif action=="export_window":
      gtkaction=gtk.FILE_CHOOSER_ACTION_SAVE
      gtkbuttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_SAVE, gtk.RESPONSE_OK)
      path=NMRFriend.main_app.options.get_option("last_exported_window")
      
    else:
      gtkaction=gtk.FILE_CHOOSER_ACTION_OPEN
      gtkbuttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OPEN, gtk.RESPONSE_OK)
      path=NMRFriend.main_app.options.get_option("last_imported")

    # Build appropriate file filter list
    filterlist=[]
    
    for filtername in filefilter:
      filter=None
      if filtername == "nmr":
        filter = gtk.FileFilter()
        filter.set_name("NMR Friend file")
        filter.add_pattern("*.nmr")
      if filtername == "all":
        filter = gtk.FileFilter()
        filter.set_name("All files")
        filter.add_pattern("*")
      if filtername == "bruker":
        filter = gtk.FileFilter()
        filter.set_name("Bruker 1D files")
        filter.add_pattern("fid")
        filter.add_pattern("1r")
        filter.add_pattern("1i")
      if filtername == "ascii":
        filter = gtk.FileFilter()
        filter.set_name("ASCII files")
        filter.add_pattern("*.txt")
        filter.add_pattern("*.csv")
        filter.add_pattern("*.dat")
      if filter!=None:
        filterlist.append(filter)
    
    # create dialog
    dialog = gtk.FileChooserDialog(title,
                               None,
                               gtkaction,
                               gtkbuttons)
    dialog.set_default_response(gtk.RESPONSE_OK)
    dialog.set_do_overwrite_confirmation(True)
    
    # add filter to filechooser
    for filter in filterlist:
      dialog.add_filter(filter)
    
    # select correct folder
    dialog.set_current_folder(path)
    
    # set current name
    #dialog.set_current_name ('')
    
    # show dialog
    response = dialog.run()
    # get selected file (if selected!)
    selectedfile=None
    if response == gtk.RESPONSE_OK:
      selectedfile=dialog.get_filename()
    else:
      pass
    #print "response:",response
    #kill dialog
    dialog.destroy()
      
    return selectedfile

class Waiting_window(gtk.Dialog):
    def __init__(self, parent, text = "Doing something fancy..."):
        
        # Call ancestor __init__
        gtk.Dialog.__init__(self, parent = parent)
        
        # Initialize variables
        self._timer = None
        
        # Window widget setup
        self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
        self.set_border_width(10)
        self.set_decorated(False)
        
        self.set_type_hint(gtk.gdk.WINDOW_TYPE_HINT_SPLASHSCREEN)
        self.set_destroy_with_parent(True)
        self.set_modal(False)
        
        # Initialize children widgets
        #self.vbox=gtk.VBox()
        self.title_label=gtk.Label()
        self.progress_bar=gtk.ProgressBar()
    
        
        # Label widget setup
        self.title_label.set_markup(text)
        
        # Add widgets to vbox
        self.vbox.pack_start(self.title_label, True, False, 10)
        self.vbox.pack_start(self.progress_bar, True, False, 10)
        
        # Add vbox to window
        #self.add(self.vbox)
        
        # Show widgets
        self.show_all()
  
    def start_pulsing(self):
        self._timer = threading.Timer(0.05, self.start_pulsing)
        self._timer.start()
        self.pulse()
      
    def stop_pulsing(self):
        try :
            self._timer.cancel()
            time.sleep(0.05)
        except AttributeError:
            pass
        self._timer = None
      
    def pulse(self):
        self.progress_bar.pulse()
        # Refresh progress bar
        while gtk.events_pending():
            gtk.main_iteration()

    def task_done(self):
        self.stop_pulsing()
        self.progress_bar.set_text("DONE!")
            
        self.progress_bar.set_fraction(1.0)
        
        self.destroy()
        # Refresh progress bar
        while gtk.events_pending():
            gtk.main_iteration()
