import math,os,sys

def isNumber(strtocheck):
  """Check if the given string is a number. Return True if yes, False if not."""
  try:
    #Check if it is a number
    tmp=float(strtocheck)
  except ValueError:
    return False
  else:
    return True

def isBool(strtocheck):
  """Check if the given string is a number. Return True if yes, False if not."""
  strtocheck=str(strtocheck).strip()
  if strtocheck==("True" or "true" or "TRUE" or "1" or "on" or "On" or "ON") or ("False" or "FALSE" or "false" or "0" or "off" or "Off" or "OFF"):
    return True
  else:
    return False
  
def str2bool(strtoparse):
  """Converts given string to boolean.
  Returns equivalent boolean or string if no equivalent found."""
  strtoparse=str(strtoparse).strip()
  if strtoparse==("True" or "true" or "TRUE" or "1" or "on" or "On" or "ON"):
    return True
  elif strtoparse==("False" or "FALSE" or "false" or "0" or "off" or "Off" or "OFF"):
    return False
  else:
    return strtoparse

def str2num(strtoparse):
  """Converts a string to the most adequate number format if possible. Results the number or passed string if not possible"""
  strtoparse=str(strtoparse).strip()
  
  if isNumber(strtoparse):
    tmpnum=float(strtoparse)
    if str(int(tmpnum))==strtoparse:
      return int(tmpnum)
    else:
      return tmpnum
  elif isBool(strtoparse):
    return str2bool(strtoparse)
  else:
    return strtoparse

def format_tick(x,pos):
  """Format a tick number"""
  if x==int(x):
    return "%d" % x
  else:
    try:
      format="%."+str(max(0,-int(math.log10(abs(x)))+3))+"f"
      return (format % x)
    except:
      return "%.2f" % x

def safe_name(name,list_name):
  """Seek for name in list_name.
  If name is not present in the list, name can be use.
  If name is present, check sanity of name(1)...etc.
  Finally returns safe usable name based on given name."""
  
  safe_name=name
  count=0
  #Check if list_name equals None
  if list_name == None:
    return safe_name
  
  while safe_name in list_name:
    if count > 0:
      safe_name=name+" ("+str(count)+")"
    
    count += 1
  
  return safe_name

def make_unique(dupl_list=[]):
  """Delete duplicated element of dupl_list and returns unique list"""
  d = {}
  for item in dupl_list:
      d[item] = None
  return d.keys()

def make_rect_table(num_elm):
  """Returns (rows,columns) corresponding to num_elm in order to build a table"""
  if num_elm==0:
    return 0,0
  
  rows=int(math.ceil(math.sqrt(num_elm)))
  columns=int(math.ceil(num_elm/float(rows)))
  
  return rows,columns

def find_common_string(strlist):
  """Return the longest string common to all strings in strlist"""
  
  for i in range(len(strlist[0])+1):
    common_str=strlist[0][:i]
    for strelm in strlist:
      if not strelm.startswith(common_str):
        common_str=common_str[:-1]
        return common_str
  return common_str
    
def build_user_path():
  """Create or returns NMR Friend user directory."""
  path=os.path.expanduser('~')
  
  if sys.platform.find("win32")>-1:
    path=os.path.join(path,"Application Data","NMRFriend")
  else:
    path=os.path.join(path,".nmrfriend")
  
  # Create path if not exists
  if not os.path.exists(path):
    os.mkdir(path)
  
  return path